﻿using System;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using ThinkGeo.MapSuite.Core;
using System.Collections.ObjectModel;
using System.Xml.Serialization;
using System.IO;

namespace RequestWebService.Web
{
    /// <summary>
    /// Summary description for ReadFeatureFromMsSql
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class ReadFeatureFromMsSql : System.Web.Services.WebService
    {
        [WebMethod]
        public Collection<FeatureInfo> LoadAMapFromMsSQL2008()
        {
            string connectString = @"Data Source=server;Initial Catalog=database;Persist Security Info=True;User ID=userid;Password=pwd;";
            MsSql2008FeatureLayer sql2008Layer = new MsSql2008FeatureLayer(connectString, "states", "recid");

            sql2008Layer.Open();
            Collection<Feature> features = sql2008Layer.FeatureSource.GetAllFeatures(ReturningColumnsType.AllColumns);
            Collection<FeatureInfo> featureInfor = new Collection<FeatureInfo>();
            foreach (Feature feature in features)
            {
                FeatureInfo featureInfo = new FeatureInfo();
                featureInfo.ID = feature.Id;
                featureInfo.WKT = feature.GetWellKnownText();

                foreach (KeyValuePair<string, string> item in feature.ColumnValues)
                {
                    FeatureAttribute featureAttibute = new FeatureAttribute();
                    featureAttibute.name = item.Key;
                    featureAttibute.value = item.Value;
                    featureInfo.Attributes.Add(featureAttibute);
                }
                featureInfor.Add(featureInfo);
            }
            sql2008Layer.Close();

            return featureInfor;
        }
    }
}
