﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using ThinkGeo.MapSuite.SilverlightEdition;
using System.Collections.ObjectModel;
using RequestWebService.ReadMsSql;

namespace RequestWebService
{

    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        private void Map_Loaded(object sender, RoutedEventArgs e)
        {
            Map1.MapUnit = GeographyUnit.DecimalDegree;
            Map1.MapTools.OverlaySwitcher.Visibility = Visibility.Visible;

            ReadMsSql.ReadFeatureFromMsSqlSoapClient userPoxy = new RequestWebService.ReadMsSql.ReadFeatureFromMsSqlSoapClient();
            userPoxy.LoadAMapFromMsSQL2008Completed += new EventHandler<RequestWebService.ReadMsSql.LoadAMapFromMsSQL2008CompletedEventArgs>(userPoxy_LoadAMapFromMsSQL2008Completed);
            userPoxy.LoadAMapFromMsSQL2008Async();

            Map1.CurrentExtent = new RectangleShape(-131.22, 53.05, -60.03, 16.91);
        }

        void userPoxy_LoadAMapFromMsSQL2008Completed(object sender, RequestWebService.ReadMsSql.LoadAMapFromMsSQL2008CompletedEventArgs e)
        {
            if (e.Error == null)
            {
                Application.Current.RootVisual.Dispatcher.BeginInvoke(delegate
                {
                    // Fetch all features from server
                    Collection<FeatureInfo> features = e.Result as Collection<FeatureInfo>;

                    // Create a Layer to render the features
                    InMemoryFeatureLayer featureLayer = new InMemoryFeatureLayer();
                    foreach (FeatureAttribute column in features[0].Attributes)
                    {
                        featureLayer.Columns.Add(new FeatureSourceColumn(column.name));
                    }

                    // Add features to the Layer
                    foreach (FeatureInfo item in features)
                    {
                        Feature feature = new Feature(item.WKT, item.ID);
                        foreach (FeatureAttribute column in item.Attributes)
                        {
                            feature.ColumnValues[column.name] = column.value;
                        }
                        featureLayer.InternalFeatures.Add(item.ID, feature);
                    }

                    featureLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.State1;
                    featureLayer.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.State1("STATE_NAME");
                    featureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                    LayerOverlay overlay = new LayerOverlay("MSSQL Overlay");
                    overlay.Layers.Add(featureLayer);
                    Map1.Overlays.Add(overlay);
                    Map1.Refresh();
                });
            }
            else
            {
                string error = e.Error.Message;
            }
        }
    }
}
